class Edge
{
  public:
	  Edge(double weight,char type,node n1,node n2) : EdgeValue(UNDEFINED),Voltage(UNDEFINED),edgeCovered(false),devCharNotSatisfied(false)
	  {
		(type=='V')?Voltage=weight:EdgeValue=weight;
		EdgeType=type;
		 Source=n1;
		g2Source=n1;
		 Sink=n2;
		g2Sink=n2;
	  }
	  ~Edge() {
		delete Source;
		delete Sink;
		delete g2Source;
		delete g2Sink;
 		cout<<"Deleting Edges"<<endl;
	  }            // Destructor
	  inline bool isEdgeType(char type) { return EdgeType==type;}
	  inline void shortg2Edge()
      { 
		 node n1,n2;
		if (g2Source->nodeNumber > g2Sink->nodeNumber)
		{
		  n1 = g2Sink;
		  n2 = g2Source;
		}
		else
		{
		  n1 = g2Source;
		  n2 = g2Sink;
		}

		for(list<Edge*>::iterator itr=n2->g2edgeList.begin();itr!=n2->g2edgeList.end();++itr)
		  ((*itr)->g2Source == n2)?((*itr)->g2Source=n1):((*itr)->g2Sink=n1);       // still not linear time ..
		n1->g2edgeList.splice( n1->g2edgeList.end(),n2->g2edgeList);
	  } 					
	  
	  inline void shortEdge()
      { 
		 node n1,n2;
		if (Source->nodeNumber > Sink->nodeNumber)
		{
		  n1 = Sink;
		  n2 = Source;
		}
		else
		{
		  n1 = Source;
		  n2 = Sink;
		}
        if(n1==n2) 
		{
		  cout << " Voltage Source Loop Found. Circuit Cannot be simulated " << endl;
		  cout << " Exiting Abnormally " << endl; 
		  exit(0);
		} 
		for(list<Edge*>::iterator itr=n2->edgeList.begin();itr!=n2->edgeList.end();++itr)
		  ((*itr)->Source == n2)?((*itr)->Source=n1):((*itr)->Sink=n1);       // still not linear time ..
		n1->edgeList.splice( n1->edgeList.end(),n2->edgeList);
	  } 					

	  double EdgeValue;
	  double Voltage;
	  node Source;
	  node Sink;
	  node g2Source;
	  node g2Sink;
	  char EdgeType;
	  bool edgeCovered;
	  bool devCharNotSatisfied;
};



