class Edge;
class Node
{
	public:
		double potential;
		int nodeNumber;
		int node1; 
		list<Edge*> edgeList;
		list<Edge*> g2edgeList;
		
		inline Node (int number) : potential(0)             // Constructor
		{
			nodeNumber=number;
		}

		~Node()
		{
		  edgeList.clear();
		  g2edgeList.clear();
		} 	// Destructor
		
		inline void addEdgeList(Edge* edgeAdded)
		{
		   edgeList.push_back(edgeAdded);
		   g2edgeList.push_back(edgeAdded);
		}
};
