class Edge
{
  public:
	  Edge(node n1,node n2,int capacity,int cost, double current,char type) : edgeCovered(false),EdgeType('a')
	  {
		 EdgeClass=type;
                 EdgeCost=cost;
                 EdgeCurrent=current; 
		 EdgeCapacity=capacity;
 		 Source=n1;
		 Sink=n2;
	  }
	  ~Edge() {
		delete Source;
		delete Sink;
	  }            // Destructor
	  inline bool isEdgeType(char type) { return EdgeType==type;}
	  inline bool isEdgeClass(char type) { return EdgeClass==type;}

	  inline void shortEdge()
      { 
		 node n1,n2;
		if (Source->nodeNumber > Sink->nodeNumber)
		{
		  n1 = Sink;
		  n2 = Source;
		}
		else
		{
		  n1 = Source;
		  n2 = Sink;
		}
        if(n1==n2) 
		{
		  cout << " Voltage Source Loop Found. Circuit Cannot be simulated " << endl;
		  cout << " Exiting Abnormally " << endl; 
		  exit(0);
		} 
		for(list<Edge*>::iterator itr=n2->edgeList.begin();itr!=n2->edgeList.end();++itr)
		  ((*itr)->Source == n2)?((*itr)->Source=n1):((*itr)->Sink=n1);       // still not linear time ..
		n1->edgeList.splice( n1->edgeList.end(),n2->edgeList);
	  } 					

	  node Source;
	  node Sink;
          int EdgeCost;
	  int EdgeCapacity;
          double EdgeCurrent;
	  char EdgeClass;
          char edgeCovered;
 	  char EdgeType;
};



