class FlowGraph 
{
  private:
	int _Nodes;
	int _Edges;
        int _SimplifiedEdges;
	int nodeCurrent;
	int flowSource;
	int flowSink;
        node* nodePtrList;
	edge* edgePtrList;
  public:
    void deleteGraph() { 
	  delete [] edgePtrList;
	  delete [] nodePtrList;
	}

	FlowGraph() : _Nodes(0),_Edges(0),_SimplifiedEdges(0),nodeCurrent(0),flowSource(0),flowSink(0){}
	bool classifyFlowEdges(char*);
	void addFlowEdge(node,node,int,int,double,char,int&);
	void findCurrentSources();
 	void findLoopOfUnsaturatedEdges();
	void replaceSaturatedEdges();
 	void replaceOffEdges();
	void buildNewProblem(char*);
};

