#include "costCorr.h"

int main (int argc, char **argv)
{
  if (argc != 7)
  {
	printf("Usage : %s circuit-name circuit-sol-file shortest-path-graph source-node scaler up/down(u/d)\n",argv[0]);
	exit (1);
  }
  clock_t init_time = clock ();

  // Here it checks for the negative cycles

  double volScaleFactor = 0;
  FILE *fpScaleFactor = fopen(".scaleFactorInfo","r");
  fscanf(fpScaleFactor,"%lf\n",&volScaleFactor);
  fclose(fpScaleFactor);

  cout << "volScaleFactor :: " << volScaleFactor << endl;

  correctCost(argv[1],argv[2],argv[3],atoi(argv[4]),volScaleFactor,argv[6][0]);

  clock_t end_time = clock ();
  cout << "Total time taken in correcting shortest path (cost) is " << double(end_time-init_time)/CLOCKS_PER_SEC << endl;

  exit(0);
}
