#include<stdio.h>
#include<stdlib.h>
#include<iostream>

#define _DC_EDGE_H

#ifndef _GLOBAL_H
#include "global.h"
#endif

#ifndef	_FORWARD_DECLARATION_H 
#include "forwardDeclaration.h"
#endif



class Edge
{
  private:
	  Int edgeNumber;
	  Int edgeWeight;
	  Node* sourceNode;
	  Node* sinkNode;
  public:
	Edge()				// Constructor
	{
	  edgeNumber=0;
	  edgeWeight=0;
	  sourceNode=NULL;
	  sinkNode=NULL;
	}
	
	void setEdgeNumber(Int number) {edgeNumber = number;}
	void setEdgeWeight(Int weight) {edgeWeight = weight;}
	void setEdgeData(Int number,Int weight)
	{
	  edgeNumber=number; edgeWeight=weight;
	}
	Node* edgeSourceNode() {return sourceNode;}
	Node* edgeSinkNode() {return sinkNode;}
	void setSourceNode(Node* n1){sourceNode = n1;}
	void setSinkNode(Node* n2){sinkNode = n2;}
	void setNodeInfo(Node* n1,Node* n2){sourceNode=n1; sinkNode = n2;}
	Node* getSourceNode(){return sourceNode;}
	Node* getSinkNode(){return sinkNode;}
	Int getEdgeNumber(){return edgeNumber;}
	Int getEdgeWeight(){return edgeWeight;}
	void showEdgeStatistics();
	void printEdgeStatistics(Bool);
};

