#include<stdio.h>
#include<stdlib.h>
#include<iostream>
#include<time.h>
#include<list>
#include<algorithm>

#ifndef _DC_NODE_H
#include "dcNode.h"
#endif


#ifndef _GLOBAL_H
#include "../Include/global.h"
#endif

void Node::setNodeData(Int number)
{
	  nodeNumber = number;
}

void Node::showNodeData()
{
  cout << "Node number is " << nodeNumber << endl;
}
 
void Node::setAdjacencyOfNode(Edge* edgeAdded)
{
  edgesIncident.push_back(edgeAdded);
} 
void Node::setAdjacencyOfNode(Int totalEdges,Int degree,Int nodeIndex, 
	                          Bool isWeightOfEdge,Bool isDirected,
							  IntPtr edgeHistory,Node** nodePtrArray, Edge** edgePtrArray)
{
  Int adjEdge=0, edgeWeight=0;
  list<Int> histroyOfEdgesIncident;
    //cout << "Data received is " << totalEdges << " " << degree << " " << nodeIndex << endl;
  Int i=0;
  do 
  {
	adjEdge = rand()%totalEdges;
//	cout << "random edge number choosen is " << adjEdge << endl;
	if(edgeHistory[2*adjEdge]==2)
	{
	//  cout<<"Found One" << endl; 
	  continue;
	}
	
    list<Int>::const_iterator itr=find(histroyOfEdgesIncident.begin(),histroyOfEdgesIncident.end(),adjEdge);
	if(itr!=histroyOfEdgesIncident.end())
	  continue;
		
	 if(edgeHistory[2*adjEdge]==0)
	 {
	   if(isWeightOfEdge)
		 edgeWeight = rand()%MaxValueOfEdgeWeight;

	   edgePtrArray[adjEdge] = new Edge;
	   edgePtrArray[adjEdge]->setEdgeData(adjEdge,edgeWeight);
//	   cout << "edge " << adjEdge << " created! " <<endl;
	 }

	 
	 if(isDirected)
	 {
	   if(edgeHistory[2*adjEdge]==0)
	   {
		 if(!(rand()%2))
		 {
		   edgePtrArray[adjEdge]->setSinkNode(nodePtrArray[nodeIndex]);
		   edgeHistory[2*adjEdge+1]= -1;
		  // cout << "Pass 1!" << endl;
		 }
		 else
		 {
		   edgePtrArray[adjEdge]->setSourceNode(nodePtrArray[nodeIndex]);
		   edgeHistory[2*adjEdge+1]= 1;
		 //  cout << "Pass 2!" << endl;
		 }
		 
	   	   edgeHistory[2*adjEdge]++;
	   }
	   else if(edgeHistory[2*adjEdge]==1)
	   {
		 if(edgeHistory[2*adjEdge+1] == 1)
		   edgePtrArray[adjEdge]->setSinkNode(nodePtrArray[nodeIndex]);
		 else if(edgeHistory[2*adjEdge+1] == -1)
		   edgePtrArray[adjEdge]->setSourceNode(nodePtrArray[nodeIndex]);
		   
		 edgeHistory[2*adjEdge]++;
		// cout << "Pass 3!" << endl;
	   }
	 }
	 else 
	 {
	   if(edgeHistory[2*adjEdge]==0)
	   {
		 edgePtrArray[adjEdge]->setSourceNode(nodePtrArray[nodeIndex]);
		 edgeHistory[2*adjEdge+1]=0;
	   	   
//		   cout << "Pass 4!" << endl;
	   }
	   else if (edgeHistory[2*adjEdge]==1)
	   {
		 edgePtrArray[adjEdge]->setSinkNode(nodePtrArray[nodeIndex]);
		 edgeHistory[2*adjEdge+1]=0;
//		   cout << "Pass 5!" << endl;
	   }

		 edgeHistory[2*adjEdge]++;
	 }
	
	 edgesIncident.push_back(edgePtrArray[adjEdge]);
	 histroyOfEdgesIncident.push_back(adjEdge);	 
	 i++;
  }  
  while(i<degree);
  
//  list<Int>::iterator it1 = histroyOfEdgesIncident.begin() ;
/* 
 while (it1 != histroyOfEdgesIncident.end())
 {
   cout << (*it1) << " ";
   it1++; 
 }
 cout << endl; */
  histroyOfEdgesIncident.clear();
}

void Node::showNodeStatistics(Bool isNodeWeight,Bool isEdgeWeight)
{
 //Edge* currentEdge=headOfEdgesIncident;
 
// cout << "Node number is " << nodeNumber+1 << endl
//	   << " node weight is " << nodeWeight << endl
//	   << " and node degree is " << nodeDegree << endl;
// cout << "Edges incident on the node " << nodeNumber+1  
//      << " are as follows:" << endl; 
   
  cout << nodeNumber<< " " ;

 list<Edge*>::iterator it1 ;
 (it1) = edgesIncident.begin() ;
 
 while (it1 != edgesIncident.end())
 {
   (*it1)->printEdgeStatistics(isEdgeWeight) ;
   it1++; 
 }
 cout << endl;
}

void Node::removeNodeAdjacency()
{
  edgesIncident.clear();
}

void Node::modifyNodeAdjacencyByRemovingEdge(Edge*& refToEdgePtr )
{
  edgesIncident.remove(refToEdgePtr);
}
