class FGEdge
{
  public:
	  FGEdge(double weight,char type,fgnode n1,fgnode n2) : EdgeValue(UNDEFINED),Voltage(UNDEFINED),edgeCovered(false),devCharNotSatisfied(false),Capacity(0)
	  {
		(type=='V')?Voltage=weight:EdgeValue=weight;
		EdgeType=type;
		 Source=n1;
		 Sink=n2;
	  }
	  ~FGEdge() {
		delete Source;
		delete Sink;
	  }            // Destructor
	  inline bool isEdgeType(char type) { return EdgeType==type;}

	  double EdgeValue;
	  double Voltage;
	  fgnode Source;
	  fgnode Sink;
	  char EdgeType;
	  char edgeCovered;
	  bool devCharNotSatisfied;
	  int Capacity;
};



