class GraphOfNetwork 
{
  private:
	int _Nodes;
	int _Edges;
        int _SimplifiedEdges;
	int _Diode;
	int _VoltageSource;
    	int _Sparsity; 
	int NRiteration;
        int _DevCharNotSatisfied;
#ifdef MCF 
        double  scalecost; 
	double  scalecapacity;
	double  flowCost; 
	fgnode* fgNodePtrList;
	fgedge* fgEdgePtrList;
#endif 
	node firstNode; 
	node* nodePtrList;
	edge* edgePtrList;
	node* newnodePtrList; 
  public:
    void deleteGraph() { 
	  delete [] edgePtrList;
	  delete [] nodePtrList;
	}

#ifdef DCANA 	
	GraphOfNetwork() : _Nodes(0),_Edges(0),_Diode(0),_VoltageSource(0),_Sparsity(0),NRiteration(0),_DevCharNotSatisfied(0) {}
	 void convertCircuitIntoGraph(char*);
#endif 
#ifdef MCF 	 
	GraphOfNetwork() : _Nodes(0),_Edges(0),_SimplifiedEdges(0),_Diode(0),_VoltageSource(0),_Sparsity(0),NRiteration(0),_DevCharNotSatisfied(0),scalecost(0),scalecapacity(0),flowCost(0) {}
	 void convertFlowProblemToCircuit(char*,double);
     void printFlowInfo(char*);
     void scaling(void);
#endif 
	 double printSolution(char*);
     void addEdge(double,char,node,node,int&);
     void addDiodeEdge(node,node,int&);
	
	 void makeG1(); 
	 void makeG2();
	 void findG2Voltages(stack<node>&);
     //void sloan();	
	 void modifyNodeNumber();
	 void findVoltages();
	 bool checkForDevChar(int &);	
	 void findCurrents();
	 void findVoltageBranchCurrents(stack<node>&);
	 void checkForKCL();	
	 void fillMatrix(double*,int*,int*,double*);
	 void updateMatrix(double*,int*,double*);
	 void NR();
	 void findBranchVoltagesOfCompleteGraph(double*);
 	 void checkForKCLFG(char*);
 	 void flowCorrection(char*,int*&);
	 int buildTreeOfA(bool* &,int* &);
	 void extendTreeOfA(bool* &,int* &,int &counter);
	 void extendTreeOfACompleteGraph(bool* &,int* &,int &counter);
	 void findFlow(int*&);
	 int assignIntFlow(void);
         void addFgEdge(char,fgnode,fgnode,double,double,int,int&,char);
#ifdef LU 
	 void ludecomposition(double*, double*,int*,int*,int,int);
	 void choleskydecomposition(double*, double*,int*,int*,int,int);
#endif 
#ifdef CG 
	 void pcg(double*, double*,int*,int*,int,double*);
	 void snPCG(double*, double*,int*,int*,int,double*,bool);
	 void itlpcg(double*, double*,int*,int*,double*);
	 void quickSort(double*,int*,int,int);
	 int partitionElementArray(double*, int*,int,int);
#endif 
};

