#include "global.h"
int main (int argc, char **argv)
{
  clock_t init_time = clock ();
  bool secondAna=false;
  FlowGraph G;
  if (argc != 2) { 
	cerr << "Usage :" << argv[0] << " File Name "<< endl;
	exit (1);
  }
  cout << endl << "Flowgraph edges classification : " << endl; 
  secondAna=G.classifyFlowEdges(argv[1]);
  G.findCurrentSources();
  G.replaceSaturatedEdges();
  G.replaceOffEdges();
  G.buildNewProblem(argv[1]);
  cout<<"CombOptSolver  : EdgeClassification: Total Time = "<<double(clock()-init_time)/CLOCKS_PER_SEC<<endl;
  exit(0);
}
