#include<stdio.h>
#include<math.h>
#include<stdlib.h>
#include<time.h>
#include<iostream>
#include<fstream>
#include<list>
#include<queue>
#include<map>


#define _GRAPH_H

#ifndef _DC_NODE_H
#include "dcNode.h"
#endif

#ifndef _DC_EDGE_H
#include "dcEdge.h"
#endif

#ifndef _GLOBAL_H
#include "global.h"
#endif

class Graph 
{
  private:

	Int numberOfNodes;
	Int numberOfEdges;
	map<Int,Node*> nodePtrMap;
	map<Int,Edge*> edgePtrMap;

	Double timeInPrintingGraph;
	Double timeInDeletingGraph;
  public:
	Graph()		// Constructor
	{
	  numberOfNodes=0;
	  numberOfEdges=0;
	}	
	Int totalNumberOfNodes(){return numberOfNodes;}
	Int totalNumberOfEdges(){return numberOfEdges;}
	void setGraphEdgeCount(Int edges){numberOfEdges = edges;}
	map<Int,Node*>& refToNodePtrMap(){return nodePtrMap;}
	map<Int,Edge*>& refToEdgePtrMap(){return edgePtrMap;}

	void setGraphParameters(Int,Int);
	void prepareAdjacencyOfCircuit(Int,Int,Int,Int);
	void printGraph();
	void deleteGraph();
	void findNodePotentialsOfGraph(int *);
};
