#include<time.h>
#include<list>

#define _CONVERTER_H

#ifndef _GLOBAL_H
#include "global.h"
#endif
        
#ifndef _GRAPH_H
#include "Graph.h"
#endif

class converter
{
  private:
	Int numberOfNodes;
	Int numberOfBranches;
	Graph networkGraph;
	clock_t init,final;
	double timeInGraphToCircuitConversion;
	double timeInDeletetionOfGraph;
  public:
	converter()
	{
	  numberOfNodes=0;
	  numberOfBranches=0;
	  timeInGraphToCircuitConversion=0;
	  timeInDeletetionOfGraph=0;
	}
	//void convertCircuitIntoGraph(char *,list<Edge*>&,map<Int,Double>&);
	
    Int getNumberOfNodesInCircuit(){return numberOfNodes;}
    Int getNumberOfBranchesInCircuit(){return numberOfBranches;}
	Int findTheBiggestNumber(Int,Int,Int);
    void printGraphOfNetwork(Graph&);
    void printGraphOfNetwork();
    void deleteGraphOfNetwork(Graph&);
	Graph& _networkGraph(){return networkGraph;}
	Graph isNetworkGraph(){return networkGraph;}
	
	void readGraph(char *);
	void convertGraphIntoElectricalCkt(char *,int);
	void calculateCostAndGenerateElectricalCkt(char*, int*,int);
	
	Double getTimeInGraphToCircuitConversion(){return timeInGraphToCircuitConversion;}
	Double getTimeInDeletetionOfGraph(){return timeInDeletetionOfGraph;}
	
	void printTimingInfo();
};
