#include<stdio.h>
#include<stdlib.h>
#include<iostream>
#include<list>


#define _DC_NODE_H

#ifndef _DC_EDGE_H
#include "dcEdge.h"
#endif

#ifndef _GLOBAL_H
#include "global.h"
#endif


class Node 
{
  private:
	  Int nodeNumber;
	  list<Edge*> edgesIncident;
  public:
	Node()				// Constructor
	{
	  nodeNumber=0;
	}

	void setNodeNumber(Int number) {nodeNumber = number;}
	Int getNodeNumber() {return nodeNumber;}
	list<Edge*>& getEdgesIncidentOnNode() {return edgesIncident;}
    void modifyNodeAdjacencyByRemovingEdge(Edge*&);
	void setNodeData(Int);
	void showNodeData();
	void showNodeStatistics(Bool,Bool);
	
	void setAdjacencyOfNode(Int,Int,Int,Bool,Bool,IntPtr,Node**,Edge**);	// Sets edges incident on node
	void setAdjacencyOfNode(Edge*);	// Sets edges incident on node

	void setEdgesIncidentOnNode(Node*);
	void removeNodeAdjacency();
};

